local myname="ZifnabsFunctions"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={f=Me} else ZifnabsMod.f=Me end
local mod
local L
local db
local fw

local sound={["SOULSTONEOUT"]=SOUNDKIT.RAID_WARNING,["ERROR"]=SOUNDKIT.GM_CHAT_WARNING,["REMINDER"]=SOUNDKIT.LFG_REWARDS,["BOING"]=800} -- 800=GS_LOGIN, funzt mit Namen aber nicht
local SOUNDPATH="Interface\\AddOns\\Zifnabs\\Sound\\"

local infight=false

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	fw=fwinfo
	mod=fw.mod
	L=fw.L
	db=fw.db
	mod.core:Register4Event("PLAYER_REGEN_ENABLED","f",Me.PLAYER_REGEN_ENABLED)
	mod.core:Register4Event("PLAYER_REGEN_DISABLED","f",Me.PLAYER_REGEN_DISABLED)
end

-- --------------------------------------------------------------------------------------
-- PLAYER_REGENENABLED/DISABLED
-- --------------------------------------------------------------------------------------
function Me:PLAYER_REGEN_ENABLED() infight=false end
function Me:PLAYER_REGEN_DISABLED() infight=true end
function Me:InFight() return infight end

function Me:CopyTable(intable)
	local outtable=nil
	if type(intable)~="table" then outtable=intable
	else
		outtable={}
		for key,value in pairs(intable) do
			outtable[key]=Me:CopyTable(value)
		end
	end
	return outtable
end

-- --------------------------------------------------------------------------------------
-- SPLIT
-- --------------------------------------------------------------------------------------
function Me:Split(text,separator,maxparts)
	local part={}
	local pn=0
	while text and text~="" and (not maxparts or pn<maxparts) do
		if separator==" " then text=Me:Trim(text) end
		local ix=string.find(text,separator)
		pn=pn+1
		if not ix or pn==maxparts then
			part[pn]=text
			text=""
		else
			part[pn]=string.sub(text,1,ix-1)
			text=string.sub(text,ix+string.len(separator))
		end
	end
	return part
end

-- --------------------------------------------------------------------------------------
-- TRIM
-- --------------------------------------------------------------------------------------
function Me:Trim(text)
	while text and string.len(text)>0 and string.sub(text,1,1)==" " do 
		text=string.sub(text,2) 
	end
	while text and string.len(text)>0 and string.sub(text,-1,-1)==" " do 
		text=string.sub(text,1,-2) 
	end
	return text
end

-- --------------------------------------------------------------------------------------
-- REPL
-- --------------------------------------------------------------------------------------
function Me:Repl(text,replarray)
	for search,replacement in pairs(replarray) do
		search="<"..search..">"
		local searchlen=strlen(search)
		local i=0
		while i<strlen(text) do
			if strsub(text,i,i+searchlen-1)~=search then i=i+1
			else
				text=strsub(text,1,i-1)..replacement..strsub(text,i+searchlen)
				i=i+strlen(replacement)
			end
		end
	end
	return text
end

-- --------------------------------------------------------------------------------------
-- PRINT
-- --------------------------------------------------------------------------------------
function Me:Debug(text,replarray) Me:PrintR(Me:Color(text,"c0c070"),replarray or {}) end
function Me:PrintR(text,replarray,soundname) Me:Print(Me:Repl(text,replarray),soundname) end
function Me:Print(text,soundname,prefix,color)
	if not prefix then prefix=Me:Color((fw.framework or "*unknown*"),"ddbb00")..": " end
	if not color then color="bbdd44" end
	DEFAULT_CHAT_FRAME:AddMessage(prefix..Me:Color(text,color))
	if soundname~=nil then Me:Sound(soundname) end
end

-- --------------------------------------------------------------------------------------
-- SOUND
-- --------------------------------------------------------------------------------------
function Me:Sound(nameornumber)
	local play=nameornumber
	if play then
		if sound[nameornumber] then play=sound[nameornumber] end
		if string.find(play,".mp3") then 
			PlaySoundFile(SOUNDPATH..play) 
		else 
			PlaySound(play) 
		end
	end
end

-- --------------------------------------------------------------------------------------
-- COLOR
-- --------------------------------------------------------------------------------------
function Me:Color(text,color,ambient) return "|c"..(ambient or "ff")..color..text.."|r" end